/*
*  @description: 变更公共公共方法
  @Modifier: haoFx
  @routerPath:
  @date: 2020/3/24-15:12*/
/* 接口*/
import { getChangeBulletinInfo } from '@/api/bidding/changeBulletin'
import { formatTimeSecond } from '@/assets/js/utils' // 保存时间初始化00秒
const changeBulletinCommon = {
  data() {
    return {
      confirmLoading: false, // 控制按钮重复点击Loding
      tenderId: this.$route.query.id, // 项目id
      flowStatus: this.$route.query.flowStatus, // true 工作流进入驳回编辑
      changeBulletinId: '', // 变更公告id
      // 上传附件参数
      upLoadData: {
        bizId: '', // 业务主键Id
        fileType: 'change_bulletin_attachment_base'// 文件类型
      },
      // 获取公告内容pdf
      bulletinContentData: {
        bizId: '', // 业务主键Id
        fileType: 'changeBulletinContent'// 文件类型
      },
      formData: {
        processInitDto: {},
        tenderDocumentReceiveTime: [], // 标书获取时间 =》前端展示，不需要传给后端
        newAcceptAnsweringQuestionsEndTime: '', // 新接受答疑截止时间
        newOpenBidStartTime: '', // 新开标时间
        newTenderDocumentReceiveEndTime: '', // 新标书获取截止时间
        newTenderDocumentReceiveStartTime: '', // 新标书获取开始时间
        packInfo: [], // 可变更标段信息
        remarks: '', // 变更公告备注
        title: '', // 公告标题
        requestMethod: '' // 请求方式 保存时 00:处理html内容 01:不处理html内容
      },
      systemSourceType: '', // 是否使用工具制作 布尔值
      // 配置变更公告编辑路由 初始化和变更公告进入路由不同
      changeBulletinPath: {
        changeBulletinAddPath: '/bidding/projectDrive/changeBulletin/changeBulletinAdd', // 变更公告新增选择标包路由
        makeChangeBulletinPath: '/bidding/projectDrive/changeBulletin/makeChangeBulletinAdd', // 富文本编辑器编辑变更公告路由
        submitChangeBulletinPath: '/bidding/projectDrive/changeBulletin/submitChangeBulletin', // 变更公告提交路由
        submitListPath: '/bidding/projectDrive/changeBulletin/changeBulletinList', // 变更公告提交后跳转路由
        toolMakeChangeBulletinPath: '/bidding/projectDrive/changeBulletin/toolMakeChangeBulletin', // 使用工具制作
        pdfDetailPath: '/bidding/projectDrive/changeBulletin/makeChangeBulletinPdfDetail' // 预览pdf
      }
    }
  },
  created() {
    this.changeBulletinId = this.flowStatus ? this.$route.query.bizId : this.$route.query.changeBulletinId
    this.handlePath()
  },
  mounted() {
    this.initChangeBulletinInfo()
    this.lodSysTemSource()// 获取系统来源
  },
  methods: {
    // 获取系统来源
    lodSysTemSource() {
      this.$store.dispatch('getSystemSource', 'changeBulletin').then(() => {
        this.systemSourceType = this.$store.getters.systemSourceVo.systemSourceCode // 01 工具制作模式 00 平台制作模式
        if (this.systemSourceType === '01') {
          this.formData.requestMethod = '01'// 01:不处理html内容
        } else {
          this.formData.requestMethod = '00'// 00:处理html内容
        }
      }).catch(() => {
      })
    },
    // 配置变更公告路径
    handlePath() {
      // 变更公告id
      let changeBulletinPath = {}
      // 审批流进入变更公告
      if (this.flowStatus) {
        changeBulletinPath = {
          changeBulletinAddPath: '/work/changeBulletin/changeBulletinUpdate', // 变更公告新增选择标包路由
          makeChangeBulletinPath: '/work/changeBulletin/makeChangeBulletinAdd', // 富文本编辑器编辑变更公告路由
          submitChangeBulletinPath: '/work/changeBulletin/submitChangeBulletin', // 变更公告提交路由
          submitListPath: '/work/todo', // 提交后跳转路由
          toolMakeChangeBulletinPath: '/work/changeBulletin/toolMakeChangeBulletin', // 使用工具制作
          pdfDetailPath: '/work/changeBulletin/changeBulletinDetail' // 预览pdf
        }
        this.changeBulletinPath = changeBulletinPath // 配置路径
      }
    },
    // 查看变更公告
    initChangeBulletinInfo() {
      getChangeBulletinInfo(this.changeBulletinId).then(res => {
        if (this.changeBulletinId) {
          this.formData = Object.assign(this.formData, res.data)
          // 编辑页面的，根据阶段id集合查询时间规则信息(时间都在这里赋的值)
          if (this.formData.packInfo.length > 0 && this.selectStageTimeRuleInfo) {
            this.selectStageTimeRuleInfo()
          } else {
            // 其他处理
            // 标书获取时间
            if (this.formData.newTenderDocumentReceiveStartTime) {
              this.formData.tenderDocumentReceiveTime = [
                this.formData.newTenderDocumentReceiveStartTime, // 开始时间
                this.formData.newTenderDocumentReceiveEndTime// 结束时间
              ]
            }
          }
        } else {
          // 变更公告标题
          this.formData.title = this.tenderBase.tenderName + '变更公告'
        }
      }).catch(() => {

      })
    },
    // 保存组装数据
    assemblyData() {
      const data = {
        ...this.formData,
        isSubmit: this.isSubmit, // 是否提交 00否 01是
        tenderId: this.tenderId,
        changeBulletinId: this.changeBulletinId // 变更公告Id
      }

      // 新接受答疑截止时间
      if (data.newAcceptAnsweringQuestionsEndTime) {
        data.newAcceptAnsweringQuestionsEndTime = formatTimeSecond(data.newAcceptAnsweringQuestionsEndTime)
      }
      // 新开标时间
      if (data.newOpenBidStartTime) {
        data.newOpenBidStartTime = formatTimeSecond(data.newOpenBidStartTime)
      }
      // 新标书获取截止时间
      if (data.newTenderDocumentReceiveEndTime) {
        data.newTenderDocumentReceiveEndTime = formatTimeSecond(data.newTenderDocumentReceiveEndTime)
      }
      // 新标书获取开始时间
      if (data.newTenderDocumentReceiveStartTime) {
        data.newTenderDocumentReceiveStartTime = formatTimeSecond(data.newTenderDocumentReceiveStartTime)
      }

      // 删除不需要的参数
      delete data.tenderDocumentReceiveTime // 标书获取截止时间
      return data
    }
  }
}
export { changeBulletinCommon }
